#include <bits/stdc++.h>
using namespace std;

const int MAXN = 300030;
long long p[MAXN];
long long d[MAXN];
long long k[MAXN];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> d[i] >> p[i];
	}
	for (int i = 0; i < q; i++) {
		cin >> k[i];
	}

	int i = 0;
	long long pojedeno = 0;
	long long poslednji_dan = 0;
	for (int j = 0; j < q; j++) {
		while(i < n && d[i] <= k[j]) {
			pojedeno += p[i];
			if (poslednji_dan < d[i]) {
				poslednji_dan = d[i] + p[i] - 1;
			}
			else {
				poslednji_dan += p[i];
			}
			i++;
		}
		if (k[j] < poslednji_dan) {
			cout << pojedeno - (poslednji_dan - k[j]) << '\n';
		}
		else {
			cout << pojedeno << '\n';
		}
	}

	return 0;
}